#!/usr/bin/python
# -*- coding: utf-8 -*-
# 2011-12-13
# Autor: Esteban Bordón - ebordon@plan.ceibal.edu.uy

import os,sys
import dbus
import datetime
from ceibal.notifier import env
from ceibal.notifier.store import Db


class Notifier:
    def __init__(self, db_filename=os.path.join(env.get_data_root(),"messages.db")):
        self.db_filename = db_filename    
        #self.messages = self._get_messages()
        self.images = {"Institucional": os.path.join(env.get_images_root(), "planceibal.png")}

    def _get_messages(self, args={}):
        #query = "SELECT title, text, type, launched, expires FROM notifications order by priority desc;"
        db = Db()
        #messages = db.run_query(query)
        #if args.has_key('prioriry'):
        #    priority = args.pop('priority')
        #    messages = db.get_msg_by(args)    
        messages = filter(self._date_valid,db.get_messages(args))
        return messages

    def _date_valid(self,message):
        launched = message["launched"]
        expires = message["expires"]
        #launched = datetime.datetime.strptime(launched, "%Y-%m-%d")
        #expires = datetime.datetime.strptime(expires, "%Y-%m-%d")
        today = datetime.datetime.strftime(datetime.date.today(), "%Y-%m-%d")
        return (today >= launched) and (today <= expires)


    def show_messages_from_dbus(self):
        DBUS_NAME="org.freedesktop.Notifications"
        OBJ_PATH="/org/freedesktop/Notifications"
        icon = None
        IFACE_NAME="org.freedesktop.Notifications"
        bus = dbus.SessionBus()
        notify_obj = bus.get_object(DBUS_NAME,OBJ_PATH)
        notifications=dbus.Interface(notify_obj,IFACE_NAME)
        #hints = {'image-data': os.path.join(env.get_images_root(), "planceibal.png")}
        #icon = os.path.join(env.get_images_root(), "planceibal.png")
        icon = ''
        #TODO: Ver un poco estas opciones
        hints = {}
        #self.messages = filter(self._date_valid, self.messages)
        for message in self._get_messages():
            if message["type"] in self.images.keys():
                icon = self.images[message["type"]]
            notifications.Notify("",0,icon,message["title"],message["text"],[], hints ,-1)

    def show_messages_from_shell(self):
        from jarabe.frame import get_view
        #print "importando jarabe.frame"
        frame = get_view()
        print "getting_view"
        for message in self._get_messages():
            #if message["type"] in self.images.keys():
            #    icon = self.images[message["type"]]
            frame.add_message(body=message["text"], summary=message["title"])


        """
        icon_filename = '/home/tch/Devel/sugar-jhbuild-dx/install/share/sugar/data/icons/module-about_me.svg'

        hints = {'category' : 'presence',
                 'x-sugar-icon-file-name' : icon_filename}
        notifications.Notify("HelloWorld",0,'',"Test Summary","Test body",[],hints,-1)
        """

if __name__ == "__main__":
    n = Notifier()
    n.show_messages_from_dbus()
